Index: src/UIElements/CommandLineUI/CommandLineParser.cpp
===================================================================
--- src/UIElements/CommandLineUI/CommandLineParser.cpp	(revision 049d4a062a516272610064d56b90233235ec2ed0)
+++ src/UIElements/CommandLineUI/CommandLineParser.cpp	(revision 6285776145c5bb3604f2a9b1387bdcc7c69c1ffe)
@@ -43,5 +43,5 @@
 
 #include "Actions/Action.hpp"
-#include "Actions/ActionRegistry.hpp"
+#include "Actions/ActionQueue.hpp"
 #include "Actions/ActionTrait.hpp"
 #include "Actions/OptionRegistry.hpp"
@@ -112,5 +112,5 @@
   std::set<std::string> AlreadyAddedOptionNames;
 
-  ActionRegistry &AR = ActionRegistry::getInstance();
+  ActionRegistry &AR = ActionQueue::getInstance().getActionRegistry();
   bool ActionAlreadyAdded_flag = false;
   for (ActionRegistry::const_iterator actioniter = AR.getBeginIter(); actioniter != AR.getEndIter(); ++actioniter) {
@@ -482,5 +482,5 @@
   std::map <std::string, std::string> result;
 
-  ActionRegistry &AR = ActionRegistry::getInstance();
+  ActionRegistry &AR = ActionQueue::getInstance().getActionRegistry();
   for (ActionRegistry::const_iterator iter = AR.getBeginIter(); iter != AR.getEndIter(); ++iter)
     if ((iter->second)->Traits.hasShortForm()) {
Index: src/UIElements/CommandLineUI/CommandLineWindow.cpp
===================================================================
--- src/UIElements/CommandLineUI/CommandLineWindow.cpp	(revision 049d4a062a516272610064d56b90233235ec2ed0)
+++ src/UIElements/CommandLineUI/CommandLineWindow.cpp	(revision 6285776145c5bb3604f2a9b1387bdcc7c69c1ffe)
@@ -44,5 +44,5 @@
 
 #include "Actions/Action.hpp"
-#include "Actions/ActionRegistry.hpp"
+#include "Actions/ActionQueue.hpp"
 
 #include "UIElements/CommandLineUI/CommandLineParser.hpp"
@@ -65,12 +65,13 @@
 
 void CommandLineWindow::display() {
-  //cout << ActionRegistry::getInstance();
+  ActionRegistry &AR = ActionQueue::getInstance().getActionRegistry();
+  //cout << AR;
 
   // go through all possible actions
   LOG(0, "Calling Actions ... ");
   for (std::list<std::string>::iterator CommandRunner = CommandLineParser::getInstance().SequenceOfActions.begin(); CommandRunner != CommandLineParser::getInstance().SequenceOfActions.end(); ++CommandRunner) {
-    if (ActionRegistry::getInstance().isActionPresentByName(*CommandRunner)) {
+    if (AR.isActionPresentByName(*CommandRunner)) {
 //      LOG1, "INFO: Checking presence of " << *CommandRunner << ": " << "calling " << *CommandRunner);
-      ActionRegistry::getInstance().getActionByName(*CommandRunner)->call();
+      AR.getActionByName(*CommandRunner)->call();
     } else {
 //      LOG(1, "INFO: Checking presence of " << *CommandRunner << ": " << "absent.");
Index: src/UIElements/CommandLineUI/unittests/CommandLineParser_ActionRegistry_ConsistencyUnitTest.cpp
===================================================================
--- src/UIElements/CommandLineUI/unittests/CommandLineParser_ActionRegistry_ConsistencyUnitTest.cpp	(revision 049d4a062a516272610064d56b90233235ec2ed0)
+++ src/UIElements/CommandLineUI/unittests/CommandLineParser_ActionRegistry_ConsistencyUnitTest.cpp	(revision 6285776145c5bb3604f2a9b1387bdcc7c69c1ffe)
@@ -40,5 +40,5 @@
 
 #include "Actions/Action.hpp"
-#include "Actions/ActionRegistry.hpp"
+#include "Actions/ActionQueue.hpp"
 #include "Actions/ActionTrait.hpp"
 #include "UIElements/CommandLineUI/CommandLineParser.hpp"
@@ -62,5 +62,5 @@
 void CommandLineParser_ActionRegistry_ConsistencyTest::setUp()
 {
-  CPPUNIT_ASSERT_NO_THROW(AR = ActionRegistry::getPointer());
+  AR = &ActionQueue::getInstance().getActionRegistry();
   CLP = CommandLineParser::getPointer();
 };
@@ -70,5 +70,5 @@
 {
   CommandLineParser::purgeInstance();
-  ActionRegistry::purgeInstance();
+  ActionQueue::purgeInstance();
   // these come about because of the validators accessing them instantiated
   // by ActionRegistry. In ActionRegistryUnitTest we used stubs for them but
Index: src/UIElements/Menu/Menu.cpp
===================================================================
--- src/UIElements/Menu/Menu.cpp	(revision 049d4a062a516272610064d56b90233235ec2ed0)
+++ src/UIElements/Menu/Menu.cpp	(revision 6285776145c5bb3604f2a9b1387bdcc7c69c1ffe)
@@ -37,6 +37,6 @@
 #include <iostream>
 
-#include "Actions/ActionRegistry.hpp"
 #include "Actions/Action.hpp"
+#include "Actions/ActionQueue.hpp"
 #include "Actions/ActionTrait.hpp"
 #include "Menu/Menu.hpp"
@@ -122,5 +122,5 @@
 {
   // go through all actions and add those belonging to this menu
-  ActionRegistry &AR = ActionRegistry::getInstance();
+  ActionRegistry &AR = ActionQueue::getInstance().getActionRegistry();
   for (ActionRegistry::const_iterator iter = AR.getBeginIter();
       iter != AR.getEndIter();
Index: src/UIElements/Menu/MenuDescription.cpp
===================================================================
--- src/UIElements/Menu/MenuDescription.cpp	(revision 049d4a062a516272610064d56b90233235ec2ed0)
+++ src/UIElements/Menu/MenuDescription.cpp	(revision 6285776145c5bb3604f2a9b1387bdcc7c69c1ffe)
@@ -39,5 +39,5 @@
 #include <string>
 
-//#include "Actions/ActionRegistry.hpp"
+//#include "Actions/ActionQueue.hpp"
 #include "Menu/MenuDescription.hpp"
 
@@ -158,5 +158,5 @@
 //  std::multimap <std::string, std::string> result;
 //
-//  ActionRegistry &AR = ActionRegistry::getInstance();
+//  ActionRegistry &AR = ActionQueue::getInstance().getActionRegistry()();
 //  for (ActionRegistry::const_iterator iter = AR.getBeginIter();iter != AR.getEndIter();++iter) {
 //    std::cout << "Inserting " << (iter->second)->getName() << " into menu " << (iter->second)->Traits.getMenuName() << std::endl;
Index: src/UIElements/Menu/Qt4/QtMenuPipe.cpp
===================================================================
--- src/UIElements/Menu/Qt4/QtMenuPipe.cpp	(revision 049d4a062a516272610064d56b90233235ec2ed0)
+++ src/UIElements/Menu/Qt4/QtMenuPipe.cpp	(revision 6285776145c5bb3604f2a9b1387bdcc7c69c1ffe)
@@ -40,7 +40,7 @@
 #include "QtMenuPipe.hpp"
 
-#include "Actions/ActionRegistry.hpp"
 #include "Actions/Action.hpp"
 #include "Actions/ActionExceptions.hpp"
+#include "Actions/ActionQueue.hpp"
 
 using namespace MoleCuilder;
@@ -55,5 +55,5 @@
 
 void QtMenuPipe::called() {
-  Action* action = ActionRegistry::getInstance().getActionByName(ActionName);
+  Action* action = ActionQueue::getInstance().getActionRegistry().getActionByName(ActionName);
   try{
     action->call();
Index: src/UIElements/Menu/TextMenu/ActionMenuItem.cpp
===================================================================
--- src/UIElements/Menu/TextMenu/ActionMenuItem.cpp	(revision 049d4a062a516272610064d56b90233235ec2ed0)
+++ src/UIElements/Menu/TextMenu/ActionMenuItem.cpp	(revision 6285776145c5bb3604f2a9b1387bdcc7c69c1ffe)
@@ -39,5 +39,5 @@
 #include "Menu/TextMenu/ActionMenuItem.hpp"
 #include "Actions/Action.hpp"
-#include "Actions/ActionRegistry.hpp"
+#include "Actions/ActionQueue.hpp"
 
 using namespace MoleCuilder;
@@ -53,10 +53,10 @@
 
 void ActionMenuItem::doTrigger() {
-  Action* action = ActionRegistry::getInstance().getActionByName(ActionName);
+  Action* action = ActionQueue::getInstance().getActionRegistry().getActionByName(ActionName);
   action->call();
 }
 
 bool ActionMenuItem::isActive() {
-  Action* action = ActionRegistry::getInstance().getActionByName(ActionName);
+  Action* action = ActionQueue::getInstance().getActionRegistry().getActionByName(ActionName);
   return action->isActive();
 }
Index: src/UIElements/Menu/TextMenu/TextMenu.hpp
===================================================================
--- src/UIElements/Menu/TextMenu/TextMenu.hpp	(revision 049d4a062a516272610064d56b90233235ec2ed0)
+++ src/UIElements/Menu/TextMenu/TextMenu.hpp	(revision 6285776145c5bb3604f2a9b1387bdcc7c69c1ffe)
@@ -25,5 +25,5 @@
 #include "Menu/MenuInterface.hpp"
 #include "Actions/Action.hpp"
-#include "Actions/ActionRegistry.hpp"
+#include "Actions/ActionQueue.hpp"
 #include "Actions/ActionTrait.hpp"
 #include "Menu/TextMenu/TxMenuLeaveAction.hpp"
@@ -148,5 +148,5 @@
         MoleCuilder::OptionTrait("leave"+token, &typeid(void), "leave menu "+token),
         token,
-        MoleCuilder::ActionRegistry::getInstance().getLastPosition(token)+2); // have a separator in between
+        MoleCuilder::ActionQueue::getInstance().getActionRegistry().getLastPosition(token)+2); // have a separator in between
     new TxMenu::LeaveAction(NewMenu->getMenuInstance(), leaveTrait);
     NewMenu->init();
Index: src/UIElements/Menu/unittests/MenuDescription_ActionRegistry_ConsistencyUnitTest.cpp
===================================================================
--- src/UIElements/Menu/unittests/MenuDescription_ActionRegistry_ConsistencyUnitTest.cpp	(revision 049d4a062a516272610064d56b90233235ec2ed0)
+++ src/UIElements/Menu/unittests/MenuDescription_ActionRegistry_ConsistencyUnitTest.cpp	(revision 6285776145c5bb3604f2a9b1387bdcc7c69c1ffe)
@@ -39,5 +39,5 @@
 
 #include "Actions/Action.hpp"
-#include "Actions/ActionRegistry.hpp"
+#include "Actions/ActionQueue.hpp"
 #include "Actions/ActionTrait.hpp"
 #include "World.hpp"
@@ -60,5 +60,5 @@
 void MenuDescription_ActionRegistry_ConsistencyTest::setUp()
 {
-  CPPUNIT_ASSERT_NO_THROW(AR = ActionRegistry::getPointer());
+  AR = &ActionQueue::getInstance().getActionRegistry();
 };
 
@@ -66,5 +66,5 @@
 void MenuDescription_ActionRegistry_ConsistencyTest::tearDown()
 {
-  ActionRegistry::purgeInstance();
+  ActionQueue::purgeInstance();
   // these come about because of the validators accessing them instantiated
   // by ActionRegistry. In ActionRegistryUnitTest we used stubs for them but
Index: src/UIElements/Qt4/QtMainWindow.cpp
===================================================================
--- src/UIElements/Qt4/QtMainWindow.cpp	(revision 049d4a062a516272610064d56b90233235ec2ed0)
+++ src/UIElements/Qt4/QtMainWindow.cpp	(revision 6285776145c5bb3604f2a9b1387bdcc7c69c1ffe)
@@ -68,5 +68,5 @@
 #include "CodePatterns/Verbose.hpp"
 #include "Actions/Action.hpp"
-#include "Actions/ActionRegistry.hpp"
+#include "Actions/ActionQueue.hpp"
 #include "Parser/ChangeTracker.hpp"
 #include "Parser/FormatParserStorage.hpp"
@@ -172,5 +172,5 @@
           MoleCuilder::WorldOutput();
         else{
-          Action* action = ActionRegistry::getInstance().getActionByName("output-as");
+          Action* action = ActionQueue::getInstance().getActionRegistry().getActionByName("output-as");
           try{
             action->call();
Index: src/UIElements/TextUI/TextWindow.cpp
===================================================================
--- src/UIElements/TextUI/TextWindow.cpp	(revision 049d4a062a516272610064d56b90233235ec2ed0)
+++ src/UIElements/TextUI/TextWindow.cpp	(revision 6285776145c5bb3604f2a9b1387bdcc7c69c1ffe)
@@ -48,5 +48,5 @@
 #include "Actions/MethodAction.hpp"
 #include "Actions/ErrorAction.hpp"
-#include "Actions/ActionRegistry.hpp"
+#include "Actions/ActionQueue.hpp"
 #include "Actions/ActionTrait.hpp"
 #include "Parser/ChangeTracker.hpp"
@@ -86,5 +86,5 @@
 
   // save has reserved key 's'
-//  Action *saveConfigAction = ActionRegistry::getInstance().getActionByName("output");
+//  Action *saveConfigAction = ActionQueue::getInstance().getActionRegistry().getActionByName("output");
   new ActionMenuItem('s',"save current setup to config files",main_menu->getMenuInstance(),"output");
 