Index: src/Fragmentation/Automation/Controller/Commands/SendResultsOperation.cpp
===================================================================
--- src/Fragmentation/Automation/Controller/Commands/SendResultsOperation.cpp	(revision 35f58778fb07584ad131cbf43ab743b1e5ab0c58)
+++ src/Fragmentation/Automation/Controller/Commands/SendResultsOperation.cpp	(revision 7670865494307829aa075e60d6056fe423885484)
@@ -31,5 +31,5 @@
 #include "CodePatterns/Log.hpp"
 #include "ControllerChoices.hpp"
-#include "FragmentResult.hpp"
+#include "Results/FragmentResult.hpp"
 
 #include "Controller/Commands/SendResultsOperation.hpp"
Index: src/Fragmentation/Automation/Controller/Commands/SendResultsOperation.hpp
===================================================================
--- src/Fragmentation/Automation/Controller/Commands/SendResultsOperation.hpp	(revision 35f58778fb07584ad131cbf43ab743b1e5ab0c58)
+++ src/Fragmentation/Automation/Controller/Commands/SendResultsOperation.hpp	(revision 7670865494307829aa075e60d6056fe423885484)
@@ -19,5 +19,5 @@
 
 #include "Connection.hpp"
-#include "FragmentResult.hpp"
+#include "Results/FragmentResult.hpp"
 
 #include "Controller/Commands/Operation.hpp"
Index: src/Fragmentation/Automation/Controller/FragmentController.hpp
===================================================================
--- src/Fragmentation/Automation/Controller/FragmentController.hpp	(revision 35f58778fb07584ad131cbf43ab743b1e5ab0c58)
+++ src/Fragmentation/Automation/Controller/FragmentController.hpp	(revision 7670865494307829aa075e60d6056fe423885484)
@@ -20,5 +20,5 @@
 #include "Connection.hpp"
 #include "Jobs/FragmentJob.hpp"
-#include "FragmentResult.hpp"
+#include "Results/FragmentResult.hpp"
 
 #include "Controller/CommandRegistry.hpp"
Index: src/Fragmentation/Automation/FragmentQueue.hpp
===================================================================
--- src/Fragmentation/Automation/FragmentQueue.hpp	(revision 35f58778fb07584ad131cbf43ab743b1e5ab0c58)
+++ src/Fragmentation/Automation/FragmentQueue.hpp	(revision 7670865494307829aa075e60d6056fe423885484)
@@ -20,5 +20,5 @@
 #include "types.hpp"
 #include "Jobs/FragmentJob.hpp"
-#include "FragmentResult.hpp"
+#include "Results/FragmentResult.hpp"
 
 class FragmentQueueTest;
Index: c/Fragmentation/Automation/FragmentResult.cpp
===================================================================
--- src/Fragmentation/Automation/FragmentResult.cpp	(revision 35f58778fb07584ad131cbf43ab743b1e5ab0c58)
+++ 	(revision )
@@ -1,92 +1,0 @@
-/*
- * Project: MoleCuilder
- * Description: creates and alters molecular systems
- * Copyright (C)  2011 University of Bonn. All rights reserved.
- * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
- */
-
-/*
- * FragmentResult.cpp
- *
- *  Created on: Oct 19, 2011
- *      Author: heber
- */
-
-// include config.h
-#ifdef HAVE_CONFIG_H
-#include <config.h>
-#endif
-
-#include "CodePatterns/MemDebug.hpp"
-
-#include "FragmentResult.hpp"
-
-/** Private default Constructor of class FragmentResult.
- *
- * This cstor is for serialization of this class inside a vector
- * only. Without it, we would not need it.
- */
-FragmentResult::FragmentResult() :
-  JobId(JobId::NoJob),
-  result(std::string("NoJob")),
-  exitflag(0)
-{}
-
-/** Constructor of class FragmentResult.
- *
- * \param _id id of FragmntJob associated to this FragmentResult.
- */
-FragmentResult::FragmentResult(const JobId_t _id) :
-  JobId(_id),
-  result(std::string("Nothing")),
-  exitflag(0)
-{}
-
-/** Constructor of class FragmentResult.
- */
-FragmentResult::FragmentResult(const JobId_t _id, const std::string _result) :
-  JobId(_id),
-  result(_result),
-  exitflag(0)
-{}
-
-/** Copy constructor of class FragmentResult.
- *
- */
-FragmentResult::FragmentResult(const FragmentResult &other) :
-  JobId(other.getId()),
-  result(other.result),
-  exitflag(other.exitflag)
-{}
-
-/** Destructor of class FragmentResult.
- *
- */
-FragmentResult::~FragmentResult()
-{}
-
-/** Equality operator: Equal if both JobIds are the same
- *
- * \param other instance to check against
- * \return true - both JobIds are the same, false - JobIds are not the same.
- */
-bool FragmentResult::operator==(const FragmentResult &other) const
-{
-  return getId() == other.getId();
-}
-
-/** Assigment operator.
- *
- * \note We can't use default assigment because of const member FragmentResult::JobId.
- *
- * \param other instance to make equal to
- */
-FragmentResult& FragmentResult::operator=(const FragmentResult &other)
-{
-  /// check self-assignment
-  if (this != &other) {
-    setId(other.getId());
-    result = other.result;
-  }
-  return *this;
-}
Index: c/Fragmentation/Automation/FragmentResult.hpp
===================================================================
--- src/Fragmentation/Automation/FragmentResult.hpp	(revision 35f58778fb07584ad131cbf43ab743b1e5ab0c58)
+++ 	(revision )
@@ -1,74 +1,0 @@
-/*
- * FragmentResult.hpp
- *
- *  Created on: Oct 19, 2011
- *      Author: heber
- */
-
-#ifndef FRAGMENTRESULT_HPP_
-#define FRAGMENTRESULT_HPP_
-
-// include config.h
-#ifdef HAVE_CONFIG_H
-#include <config.h>
-#endif
-
-
-#include <string>
-
-#include <boost/shared_ptr.hpp>
-#include <boost/serialization/array.hpp>
-#include <boost/serialization/shared_ptr.hpp>
-
-#include "JobId.hpp"
-#include "types.hpp"
-
-class FragmentQueueTest;
-class FragmentResultTest;
-
-/** This class contains the result to a specific FragmentJob.
- *
- */
-class FragmentResult : public JobId
-{
-  //!> allow FragmentQueue unit test access
-  friend class FragmentQueueTest;
-  //!> allow own unit test access
-  friend class FragmentResultTest;
-public:
-  typedef boost::shared_ptr<FragmentResult> ptr;
-
-  FragmentResult(const JobId_t id);
-  FragmentResult(const JobId_t id, const std::string _result);
-  FragmentResult(const FragmentResult &other);
-  ~FragmentResult();
-
-  FragmentResult& operator=(const FragmentResult &other);
-  bool operator==(const FragmentResult &other) const;
-  bool operator!=(const FragmentResult &other) const
-    { return !(*this == other); }
-
-  //!> result
-  std::string result;
-
-  //!> exit flag
-  int exitflag;
-
-private:
-  friend class boost::serialization::access;
-
-  /// private default constructor for serialization only.
-  FragmentResult();
-
-  // serialization
-  template <typename Archive>
-  void serialize(Archive& ar, const unsigned int version)
-  {
-    ar & boost::serialization::base_object<JobId>(*this);
-    ar & result;
-    ar & exitflag;
-  }
-};
-
-
-#endif /* FRAGMENTRESULT_HPP_ */
Index: src/Fragmentation/Automation/FragmentScheduler.hpp
===================================================================
--- src/Fragmentation/Automation/FragmentScheduler.hpp	(revision 35f58778fb07584ad131cbf43ab743b1e5ab0c58)
+++ src/Fragmentation/Automation/FragmentScheduler.hpp	(revision 7670865494307829aa075e60d6056fe423885484)
@@ -18,8 +18,9 @@
 
 #include "Connection.hpp"
+#include "ControllerChoices.hpp"
+#include "ControllerChoices.hpp"
+#include "FragmentQueue.hpp"
 #include "Jobs/FragmentJob.hpp"
-#include "FragmentQueue.hpp"
-#include "FragmentResult.hpp"
-#include "ControllerChoices.hpp"
+#include "Results/FragmentResult.hpp"
 #include "types.hpp"
 
Index: src/Fragmentation/Automation/FragmentWorker.cpp
===================================================================
--- src/Fragmentation/Automation/FragmentWorker.cpp	(revision 35f58778fb07584ad131cbf43ab743b1e5ab0c58)
+++ src/Fragmentation/Automation/FragmentWorker.cpp	(revision 7670865494307829aa075e60d6056fe423885484)
@@ -34,5 +34,5 @@
 #include "CodePatterns/Log.hpp"
 #include "Jobs/FragmentJob.hpp"
-#include "FragmentResult.hpp"
+#include "Results/FragmentResult.hpp"
 #include "FragmentWorker.hpp"
 
Index: src/Fragmentation/Automation/Jobs/FragmentJob.cpp
===================================================================
--- src/Fragmentation/Automation/Jobs/FragmentJob.cpp	(revision 35f58778fb07584ad131cbf43ab743b1e5ab0c58)
+++ src/Fragmentation/Automation/Jobs/FragmentJob.cpp	(revision 7670865494307829aa075e60d6056fe423885484)
@@ -28,5 +28,5 @@
 #include "CodePatterns/toString.hpp"
 #include "FragmentJob.hpp"
-#include "FragmentResult.hpp"
+#include "Results/FragmentResult.hpp"
 
 /** Constructor for class FragmentJob.
Index: src/Fragmentation/Automation/Jobs/FragmentJob.hpp
===================================================================
--- src/Fragmentation/Automation/Jobs/FragmentJob.hpp	(revision 35f58778fb07584ad131cbf43ab743b1e5ab0c58)
+++ src/Fragmentation/Automation/Jobs/FragmentJob.hpp	(revision 7670865494307829aa075e60d6056fe423885484)
@@ -20,5 +20,5 @@
 #include "boost/serialization/shared_ptr.hpp"
 
-#include "FragmentResult.hpp"
+#include "Results/FragmentResult.hpp"
 #include "JobId.hpp"
 #include "types.hpp"
Index: src/Fragmentation/Automation/Makefile.am
===================================================================
--- src/Fragmentation/Automation/Makefile.am	(revision 35f58778fb07584ad131cbf43ab743b1e5ab0c58)
+++ src/Fragmentation/Automation/Makefile.am	(revision 7670865494307829aa075e60d6056fe423885484)
@@ -14,13 +14,13 @@
 FRAGMENTJOBSSOURCE = \
   FragmentQueue.cpp \
-  FragmentResult.cpp \
   JobId.cpp \
-  Jobs/FragmentJob.cpp
+  Jobs/FragmentJob.cpp \
+  Results/FragmentResult.cpp
           
 FRAGMENTJOBSHEADER = \
   FragmentQueue.hpp \
-  FragmentResult.hpp \
   JobId.hpp \
-  Jobs/FragmentJob.hpp
+  Jobs/FragmentJob.hpp \
+  Results/FragmentResult.hpp
 
 noinst_LTLIBRARIES += libMolecuilderFragmentJobs.la
Index: src/Fragmentation/Automation/Results/FragmentResult.cpp
===================================================================
--- src/Fragmentation/Automation/Results/FragmentResult.cpp	(revision 7670865494307829aa075e60d6056fe423885484)
+++ src/Fragmentation/Automation/Results/FragmentResult.cpp	(revision 7670865494307829aa075e60d6056fe423885484)
@@ -0,0 +1,92 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2011 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * FragmentResult.cpp
+ *
+ *  Created on: Oct 19, 2011
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "CodePatterns/MemDebug.hpp"
+
+#include "FragmentResult.hpp"
+
+/** Private default Constructor of class FragmentResult.
+ *
+ * This cstor is for serialization of this class inside a vector
+ * only. Without it, we would not need it.
+ */
+FragmentResult::FragmentResult() :
+  JobId(JobId::NoJob),
+  result(std::string("NoJob")),
+  exitflag(0)
+{}
+
+/** Constructor of class FragmentResult.
+ *
+ * \param _id id of FragmntJob associated to this FragmentResult.
+ */
+FragmentResult::FragmentResult(const JobId_t _id) :
+  JobId(_id),
+  result(std::string("Nothing")),
+  exitflag(0)
+{}
+
+/** Constructor of class FragmentResult.
+ */
+FragmentResult::FragmentResult(const JobId_t _id, const std::string _result) :
+  JobId(_id),
+  result(_result),
+  exitflag(0)
+{}
+
+/** Copy constructor of class FragmentResult.
+ *
+ */
+FragmentResult::FragmentResult(const FragmentResult &other) :
+  JobId(other.getId()),
+  result(other.result),
+  exitflag(other.exitflag)
+{}
+
+/** Destructor of class FragmentResult.
+ *
+ */
+FragmentResult::~FragmentResult()
+{}
+
+/** Equality operator: Equal if both JobIds are the same
+ *
+ * \param other instance to check against
+ * \return true - both JobIds are the same, false - JobIds are not the same.
+ */
+bool FragmentResult::operator==(const FragmentResult &other) const
+{
+  return getId() == other.getId();
+}
+
+/** Assigment operator.
+ *
+ * \note We can't use default assigment because of const member FragmentResult::JobId.
+ *
+ * \param other instance to make equal to
+ */
+FragmentResult& FragmentResult::operator=(const FragmentResult &other)
+{
+  /// check self-assignment
+  if (this != &other) {
+    setId(other.getId());
+    result = other.result;
+  }
+  return *this;
+}
Index: src/Fragmentation/Automation/Results/FragmentResult.hpp
===================================================================
--- src/Fragmentation/Automation/Results/FragmentResult.hpp	(revision 7670865494307829aa075e60d6056fe423885484)
+++ src/Fragmentation/Automation/Results/FragmentResult.hpp	(revision 7670865494307829aa075e60d6056fe423885484)
@@ -0,0 +1,74 @@
+/*
+ * FragmentResult.hpp
+ *
+ *  Created on: Oct 19, 2011
+ *      Author: heber
+ */
+
+#ifndef FRAGMENTRESULT_HPP_
+#define FRAGMENTRESULT_HPP_
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+
+#include <string>
+
+#include <boost/shared_ptr.hpp>
+#include <boost/serialization/array.hpp>
+#include <boost/serialization/shared_ptr.hpp>
+
+#include "JobId.hpp"
+#include "types.hpp"
+
+class FragmentQueueTest;
+class FragmentResultTest;
+
+/** This class contains the result to a specific FragmentJob.
+ *
+ */
+class FragmentResult : public JobId
+{
+  //!> allow FragmentQueue unit test access
+  friend class FragmentQueueTest;
+  //!> allow own unit test access
+  friend class FragmentResultTest;
+public:
+  typedef boost::shared_ptr<FragmentResult> ptr;
+
+  FragmentResult(const JobId_t id);
+  FragmentResult(const JobId_t id, const std::string _result);
+  FragmentResult(const FragmentResult &other);
+  ~FragmentResult();
+
+  FragmentResult& operator=(const FragmentResult &other);
+  bool operator==(const FragmentResult &other) const;
+  bool operator!=(const FragmentResult &other) const
+    { return !(*this == other); }
+
+  //!> result
+  std::string result;
+
+  //!> exit flag
+  int exitflag;
+
+private:
+  friend class boost::serialization::access;
+
+  /// private default constructor for serialization only.
+  FragmentResult();
+
+  // serialization
+  template <typename Archive>
+  void serialize(Archive& ar, const unsigned int version)
+  {
+    ar & boost::serialization::base_object<JobId>(*this);
+    ar & result;
+    ar & exitflag;
+  }
+};
+
+
+#endif /* FRAGMENTRESULT_HPP_ */
Index: src/Fragmentation/Automation/controller.cpp
===================================================================
--- src/Fragmentation/Automation/controller.cpp	(revision 35f58778fb07584ad131cbf43ab743b1e5ab0c58)
+++ src/Fragmentation/Automation/controller.cpp	(revision 7670865494307829aa075e60d6056fe423885484)
@@ -40,5 +40,5 @@
 #include "Controller/Commands/ShutdownOperation.hpp"
 #include "Jobs/FragmentJob.hpp"
-#include "FragmentResult.hpp"
+#include "Results/FragmentResult.hpp"
 
 enum CommandIndices {
Index: src/Fragmentation/Automation/unittests/FragmentJobUnitTest.cpp
===================================================================
--- src/Fragmentation/Automation/unittests/FragmentJobUnitTest.cpp	(revision 35f58778fb07584ad131cbf43ab743b1e5ab0c58)
+++ src/Fragmentation/Automation/unittests/FragmentJobUnitTest.cpp	(revision 7670865494307829aa075e60d6056fe423885484)
@@ -29,5 +29,5 @@
 
 #include "Jobs/FragmentJob.hpp"
-#include "FragmentResult.hpp"
+#include "Results/FragmentResult.hpp"
 #include "JobId.hpp"
 
Index: src/Fragmentation/Automation/unittests/FragmentResultUnitTest.cpp
===================================================================
--- src/Fragmentation/Automation/unittests/FragmentResultUnitTest.cpp	(revision 35f58778fb07584ad131cbf43ab743b1e5ab0c58)
+++ src/Fragmentation/Automation/unittests/FragmentResultUnitTest.cpp	(revision 7670865494307829aa075e60d6056fe423885484)
@@ -29,5 +29,5 @@
 #include "FragmentResultUnitTest.hpp"
 
-#include "FragmentResult.hpp"
+#include "Results/FragmentResult.hpp"
 #include "JobId.hpp"
 
Index: src/Fragmentation/Automation/unittests/Makefile.am
===================================================================
--- src/Fragmentation/Automation/unittests/Makefile.am	(revision 35f58778fb07584ad131cbf43ab743b1e5ab0c58)
+++ src/Fragmentation/Automation/unittests/Makefile.am	(revision 7670865494307829aa075e60d6056fe423885484)
@@ -35,9 +35,9 @@
   unittests/FragmentJobUnitTest.hpp \
   unittests/stubs/FragmentResultStub.cpp \
-  FragmentResult.hpp \
   JobId.cpp \
   JobId.hpp \
   Jobs/FragmentJob.cpp \
-  Jobs/FragmentJob.hpp
+  Jobs/FragmentJob.hpp \
+  Results/FragmentResult.hpp
 FragmentJobUnitTest_LDADD = \
   $(BOOST_SERIALIZATION_LDFLAGS) $(BOOST_SERIALIZATION_LIBS) \
Index: src/Fragmentation/Automation/unittests/stubs/FragmentResultStub.cpp
===================================================================
--- src/Fragmentation/Automation/unittests/stubs/FragmentResultStub.cpp	(revision 35f58778fb07584ad131cbf43ab743b1e5ab0c58)
+++ src/Fragmentation/Automation/unittests/stubs/FragmentResultStub.cpp	(revision 7670865494307829aa075e60d6056fe423885484)
@@ -20,5 +20,5 @@
 #include "CodePatterns/MemDebug.hpp"
 
-#include "FragmentResult.hpp"
+#include "Results/FragmentResult.hpp"
 
 FragmentResult::FragmentResult(const JobId_t _id) :