Index: src/tesselationhelpers.cpp
===================================================================
--- src/tesselationhelpers.cpp	(revision 4178131c71823a6899287f00ea147f58b7024cd2)
+++ src/tesselationhelpers.cpp	(revision 797126567f0200a7de1f47f3329b98a9732473dd)
@@ -217,137 +217,4 @@
   Vector x3;
   Vector x4;
-};
-
-/**
- * Intersection calculation function.
- *
- * @param x to find the result for
- * @param function parameter
- */
-double MinIntersectDistance(const gsl_vector * x, void *params)
-{
-	Info FunctionInfo(__func__);
-  double retval = 0;
-  struct Intersection *I = (struct Intersection *)params;
-  Vector intersection;
-  for (int i=0;i<NDIM;i++)
-    intersection[i] = gsl_vector_get(x, i);
-
-  Vector SideA = I->x1 -I->x2 ;
-  Vector HeightA = intersection - I->x1;
-  HeightA.ProjectOntoPlane(SideA);
-
-  Vector SideB = I->x3 - I->x4;
-  Vector HeightB = intersection - I->x3;
-  HeightB.ProjectOntoPlane(SideB);
-
-  retval = HeightA.ScalarProduct(HeightA) + HeightB.ScalarProduct(HeightB);
-  //Log() << Verbose(1) << "MinIntersectDistance called, result: " << retval << endl;
-
-  return retval;
-};
-
-
-/**
- * Calculates whether there is an intersection between two lines. The first line
- * always goes through point 1 and point 2 and the second line is given by the
- * connection between point 4 and point 5.
- *
- * @param point 1 of line 1
- * @param point 2 of line 1
- * @param point 1 of line 2
- * @param point 2 of line 2
- *
- * @return true if there is an intersection between the given lines, false otherwise
- */
-bool existsIntersection(const Vector &point1, const Vector &point2, const Vector &point3, const Vector &point4)
-{
-	Info FunctionInfo(__func__);
-  bool result;
-
-  struct Intersection par;
-    par.x1 = point1;
-    par.x2 = point2;
-    par.x3 = point3;
-    par.x4 = point4;
-
-    const gsl_multimin_fminimizer_type *T = gsl_multimin_fminimizer_nmsimplex;
-    gsl_multimin_fminimizer *s = NULL;
-    gsl_vector *ss, *x;
-    gsl_multimin_function minexFunction;
-
-    size_t iter = 0;
-    int status;
-    double size;
-
-    /* Starting point */
-    x = gsl_vector_alloc(NDIM);
-    gsl_vector_set(x, 0, point1[0]);
-    gsl_vector_set(x, 1, point1[1]);
-    gsl_vector_set(x, 2, point1[2]);
-
-    /* Set initial step sizes to 1 */
-    ss = gsl_vector_alloc(NDIM);
-    gsl_vector_set_all(ss, 1.0);
-
-    /* Initialize method and iterate */
-    minexFunction.n = NDIM;
-    minexFunction.f = &MinIntersectDistance;
-    minexFunction.params = (void *)&par;
-
-    s = gsl_multimin_fminimizer_alloc(T, NDIM);
-    gsl_multimin_fminimizer_set(s, &minexFunction, x, ss);
-
-    do {
-        iter++;
-        status = gsl_multimin_fminimizer_iterate(s);
-
-        if (status) {
-          break;
-        }
-
-        size = gsl_multimin_fminimizer_size(s);
-        status = gsl_multimin_test_size(size, 1e-2);
-
-        if (status == GSL_SUCCESS) {
-          DoLog(1) && (Log() << Verbose(1) << "converged to minimum" <<  endl);
-        }
-    } while (status == GSL_CONTINUE && iter < 100);
-
-    // check whether intersection is in between or not
-  Vector intersection;
-  double t1, t2;
-  for (int i = 0; i < NDIM; i++) {
-    intersection[i] = gsl_vector_get(s->x, i);
-  }
-
-  Vector SideA = par.x2 - par.x1;
-  Vector HeightA = intersection - par.x1;
-
-  t1 = HeightA.ScalarProduct(SideA)/SideA.ScalarProduct(SideA);
-
-  Vector SideB = par.x4 - par.x3;
-  Vector HeightB = intersection - par.x3;
-
-  t2 = HeightB.ScalarProduct(SideB)/SideB.ScalarProduct(SideB);
-
-  Log() << Verbose(1) << "Intersection " << intersection << " is at "
-    << t1 << " for (" << point1 << "," << point2 << ") and at "
-    << t2 << " for (" << point3 << "," << point4 << "): ";
-
-  if (((t1 >= 0) && (t1 <= 1)) && ((t2 >= 0) && (t2 <= 1))) {
-    DoLog(1) && (Log() << Verbose(1) << "true intersection." << endl);
-    result = true;
-  } else {
-    DoLog(1) && (Log() << Verbose(1) << "intersection out of region of interest." << endl);
-    result = false;
-  }
-
-  // free minimizer stuff
-    gsl_vector_free(x);
-    gsl_vector_free(ss);
-    gsl_multimin_fminimizer_free(s);
-
-  return result;
 };
 
Index: src/tesselationhelpers.hpp
===================================================================
--- src/tesselationhelpers.hpp	(revision 4178131c71823a6899287f00ea147f58b7024cd2)
+++ src/tesselationhelpers.hpp	(revision 797126567f0200a7de1f47f3329b98a9732473dd)
@@ -51,6 +51,4 @@
 void GetCenterofCircumcircle(Vector * const Center, const Vector &a, const Vector &b, const Vector &c);
 double GetPathLengthonCircumCircle(const Vector &CircleCenter, const Vector &CirclePlaneNormal, const double CircleRadius, const Vector &NewSphereCenter, const Vector &OldSphereCenter, const Vector &NormalVector, const Vector &SearchDirection);
-double MinIntersectDistance(const gsl_vector * x, void *params);
-bool existsIntersection(const Vector &point1, const Vector &point2, const Vector &point3, const Vector &point4);
 double CalculateVolumeofGeneralTetraeder(const Vector &a, const Vector &b, const Vector &c, const Vector &d);
 double CalculateAreaofGeneralTriangle(const Vector &A, const Vector &B, const Vector &C);